<template>
  <div class="q-mx-md">
    <h4>Wijzigingen per NT-versie</h4>
    <div class="row">
      <q-card flat class="col q-mx-lg">
        <template v-if="reports">
          <q-item-section>
            <p>
              Reeds aanwezige vergelijkingsrapporten.
            </p>
          </q-item-section>

          <q-tree :nodes="reports" node-key="filename" accordion color="primary" class="tree" dense>
            <template v-slot:default-header="row">
              <q-item class="row tree_item"
                      clickable
                      dense
                      @click.stop
                      @keypress.enter.stop
                      :id="row.node.filename">
                <a :href="row.node.url" target="_Nessie">
                  <template v-if="row.node.description > ''"> {{ row.node.description }}</template>
                  <template v-else> {{ row.node.filename }}</template>
                </a>
              </q-item>
            </template>

          </q-tree>
        </template>
        <template v-else>

        </template>
      </q-card>
      <div class="col">
        <q-card flat class="col q-mx-lg detail_bg q-pa-md">
          <div class="text-h5">Vergelijk NT Versies.</div>
          <q-item-label class="q-pt-sm">
            <p>In de database opgeslagen (delen) van verschillende NT-versies kunnen met elkaar vergeleken worden
              om zo de wijzigingen te constateren.</p>
          </q-item-label>
          <div class="row q-py-sm">
            <div class="col">
              <q-select v-model="run_id" :options="run_ids" label="Run ID" color="black" bg-color="white" outlined
                        :rules="[val => !!val || 'Field is required']">
              </q-select>
            </div>
          </div>
          <q-item-label>
            Het 'Run ID' representeert een aanlevering van de NT. Normaal gesproken begint die met SBR, gevolgd door
            de KVK en de Belastingdienst (BD) later volgen OCW en BZK. De BD levert meerdere keren per jaar. Kies dan
            telkens
            BD als Run ID.
          </q-item-label>
          <div class="row q-py-sm" v-if="versions">
            <div class="col q-mr-md new-nt-version_wrapper">
              <q-select v-model="new_nt_version" :options="versions" label="Vergelijk" color="black"
                        bg-color="white" outlined></q-select>
            </div>
            <div class="col old-nt-version_wrapper">
              <q-select v-model="old_nt_version" :options="old_versions_list()" label="met oudere versie"
                        color="black" bg-color="white" outlined></q-select>
            </div>
          </div>
          <q-item-label>
            <p> Normaal gesproken kies je bij 'Vergelijk' voor de versie waar
              je zojuist een levering aan hebt toegevoegd.</p>
            <p>Bij oudere versie kies je normaal gesproken dan voor de definitieve versie die een jaar ouder is,
              maar het is theoretisch mogelijk een andere versie te kiezen. Dit zal resulteren in een nieuw rapport.</p>
          </q-item-label>
          <div class="row">
            <div class="col">
              <q-btn label="Vergelijk NT versies" color="red" class="q-ma-lg" @click="start_compare"></q-btn>
            </div>
          </div>
          <q-item-label>
            <p>Je kan elke vergelijking opnieuw draaien, de rapporten worden dan opnieuw gemaakt.</p>
            <p>Een complete vergelijking neemt zo'n twee uur in beslag.</p>
          </q-item-label>
        </q-card>

      </div>
      <q-banner v-if="submitted" class="info-banner bg-info ">
        De vergelijking is gestart.
        <template v-slot:action>
          <q-btn label="Ok" @click="submitted = false"></q-btn>
        </template>
      </q-banner>
      <q-banner v-if="error" class="info-banner text-black bg-yellow-11 q-mt-xl shadow-3">
        Alle velden zijn verplicht!
        <template v-slot:action>
          <q-btn label="Ok" @click="error = false"></q-btn>
        </template>
      </q-banner>

    </div>
  </div>
</template>

<script>
import {api} from "boot/axios";
import {Cookies} from "quasar";

export default {
  name: "CompareTax",
  data() {
    return {
      versions: undefined,
      reports: undefined,
      new_nt_version: undefined,
      old_nt_version: undefined,
      run_ids: ["SBR", "KVK", "BD", "BZK", "OCW"],
      run_id: undefined,
      submitted: false,
      error: false
    }
  },
  created() {
    this.fetchData()
    this.get_reports()
  },
  methods: {
    fetchData: function () {
      api
        .get("/nt-versions")
        .then(response => {
          this.versions = response.data.nt_versions
          if (this.versions.length > 0) {
            this.new_nt_version = this.versions[0]
          }
        })
        .catch((error) => {
          if (error.response.status == 401) {
            this.$store.commit('user/LOGOUT', '')
            if (Cookies.has('kc_token')) {
              Cookies.remove('kc_token')
            }
            this.$store.commit('user/LOGIN_ERROR', 'Sessie verlopen, log opnieuw in')
          }
        })

    },
    get_reports: function () {
      api
        .get('/admin/available-compare-reports')
        .then(response => (this.reports = response.data.reports))
    },
    old_versions_list: function () {
      let opts = []
      let that = this
      this.versions.forEach(function (item) {
        if (item.value + "z" < that.new_nt_version.value + "z") {
          opts.push(item)
        }
      })
      return opts
    },
    start_compare: function () {
      let headers = {}
      if (this.$store.state.user.token) {
        headers = {"Authorization": "Bearer " + this.$store.state.user.token}
      }
      if (this.new_nt_version && this.old_nt_version && this.run_id) {
        api
          .post('/admin/compare-versions',
            {old_nt_version: this.old_nt_version.value, new_nt_version: this.new_nt_version.value, run_id: this.run_id},
            {headers: headers})
        this.submitted = true
      } else {
        this.error = true
      }
    }
  },
}
</script>

<style scoped>
.info-banner {
  max-width: 400px;
  position: absolute;
  top: 45%;
  right: 45%;
}
</style>
